package client;

import containers.DataContainer;
import enums.ExecArgumentsEnum;
import enums.PortConfigurationEnum;
import services.AnnouncerService;
import services.FinderService;
import services.IpAddressRetrievalService;

import java.net.InetAddress;

public class PcClient {
    private AnnouncerService announcer = new AnnouncerService();
    private FinderService finder = new FinderService();
    private DataContainer container = DataContainer.getInstance();
    private IpAddressRetrievalService ipService = IpAddressRetrievalService.getInstance();

    public void run() {
        InetAddress clientAddress = ipService.getLocalIpAddress();
        container.setClientAddress(clientAddress);

        announcer
                .setTargetPort(PortConfigurationEnum.CLIENT_ANNOUNCE_PORT.getContent())
                .setAnnouncementInstanceType(ExecArgumentsEnum.RUN_CLIENT.getContent())
                .setAnnouncementIp(clientAddress.getHostAddress())
                .setAnnouncementPort(PortConfigurationEnum.CLIENT_LISTEN_PORT.getContent())
                .start();

        finder
                .setListenPort(PortConfigurationEnum.SERVER_ANNOUNCE_PORT.getContent())
                .setAddressContainer(container.getServerAddressContainer())
                .start();

    }
}
