package containers;

import java.util.concurrent.locks.ReentrantLock;

public class AbstractSynchronizedResource<T> {
    private ReentrantLock lock = new ReentrantLock();
    private T resource;

    public T getResource() {
        lock.lock();
        T resource = this.resource;
        lock.unlock();

        return resource;
    }

    public void setResource(T resource) {
        lock.lock();
        this.resource = resource;
        lock.unlock();
    }
}
