package containers;

import entities.StateGetterPackage;
import entities.StateSetterPackage;

import java.net.InetAddress;


public class DataContainer {
    private static DataContainer instance;
    private AbstractSynchronizedResource<InetAddress> serverAddress = new AbstractSynchronizedResource<>();
    private AbstractSynchronizedResource<InetAddress> clientAddress = new AbstractSynchronizedResource<>();
    private AbstractSynchronizedResource<StateSetterPackage> stateSetter = new AbstractSynchronizedResource<>();
    private AbstractSynchronizedResource<StateGetterPackage> stateGetter = new AbstractSynchronizedResource<>();

    public static DataContainer getInstance() {
        if (null == instance) {
            instance = new DataContainer();
        }

        return instance;
    }

    private DataContainer() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    while (true) {
                        Thread.sleep(2000);
                        if (null != serverAddress.getResource()) {
                            System.out.println("server address: " + serverAddress.getResource().getHostAddress());
                        }

                        if (null != clientAddress.getResource()) {
                            System.out.println("client address: " + clientAddress.getResource().getHostAddress());
                        }

                        System.out.println();
                    }
                } catch (InterruptedException e) {

                }
            }
        }).start();

    }

    public InetAddress getServerAddress() {
        return serverAddress.getResource();
    }

    public void setServerAddress(InetAddress address) {
        serverAddress.setResource(address);
    }

    public InetAddress getClientAddress() {
        return clientAddress.getResource();
    }

    public void setClientAddress(InetAddress address) {
        clientAddress.setResource(address);
    }

    public AbstractSynchronizedResource<InetAddress> getServerAddressContainer() {
        return serverAddress;
    }

    public AbstractSynchronizedResource<InetAddress> getClientAddressContainer() {
        return clientAddress;
    }

    public StateGetterPackage getStateGetter() {
        return stateGetter.getResource();
    }

    public DataContainer setStateGetter(StateGetterPackage stateGetter) {
        this.stateGetter.setResource(stateGetter);
        return this;
    }

    public StateSetterPackage getStateSetter() {
        return stateSetter.getResource();
    }

    public DataContainer setStateSetter(StateSetterPackage stateSetter) {
        this.stateSetter.setResource(stateSetter);
        return this;
    }
}
