package server;

import containers.DataContainer;
import enums.ExecArgumentsEnum;
import enums.PortConfigurationEnum;
import services.AnnouncerService;
import services.FinderService;
import services.HeadingRetrievalService;
import services.IpAddressRetrievalService;

import java.net.InetAddress;

public class CarServer {
    private AnnouncerService announcer = new AnnouncerService();
    private FinderService finder = new FinderService();
    private DataContainer container = DataContainer.getInstance();
    private IpAddressRetrievalService ipService = IpAddressRetrievalService.getInstance();
    private HeadingRetrievalService headingService = HeadingRetrievalService.getInstance();

    public void run() {
        InetAddress clientAddress = ipService.getLocalIpAddress();
        container.setServerAddress(clientAddress);

        announcer
                .setTargetPort(PortConfigurationEnum.SERVER_ANNOUNCE_PORT.getContent())
                .setAnnouncementInstanceType(ExecArgumentsEnum.RUN_SERVER.getContent())
                .setAnnouncementIp(clientAddress.getHostAddress())
                .setAnnouncementPort(PortConfigurationEnum.SERVER_LISTEN_PORT.getContent())
                .start();

        finder
                .setListenPort(PortConfigurationEnum.CLIENT_ANNOUNCE_PORT.getContent())
                .setAddressContainer(container.getClientAddressContainer())
                .start();

        try {
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
            Thread.sleep(100);
            System.out.println(headingService.read());
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}
