package services;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class LogService {
    protected static LogService instance;
    private File logFile = new File("logFile.log");
    private PrintWriter writer;

    public static LogService getInstance() {
        if (null == instance) {
            instance = new LogService();
        }

        return instance;
    }

    private LogService() {
        logFile.delete();
        try {
            writer = new PrintWriter(logFile);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    public synchronized void log(Object context, String message) {
        writer.write("[" + context.getClass().getName() + "]: " + message + "\n");
        writer.flush();
    }
}
