package services;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.IOException;

public class SerializerService {
    protected static SerializerService instance;
    public static SerializerService getInstance() {
        if (null == instance) {
            instance = new SerializerService();
        }

        return instance;
    }
    protected ObjectMapper objectMapper = new ObjectMapper();
    private LogService log = LogService.getInstance();

    public String serialize(Object o) {
        try {
            return objectMapper.writeValueAsString(o);
        } catch (JsonProcessingException e) {
            log.log(this, "Serialization error!");
        } catch (Exception e) {
            e.printStackTrace();
        }

        return null;
    }

    public <T> T deserialize(String json, Class<T> classOfT) {
        try {
            return objectMapper.readValue(json, classOfT);
        } catch (IOException e) {
            log.log(this.getClass().getName(),"Deserialization error!");
        }

        return null;
    }
}
