package services;

import containers.AbstractSynchronizedResource;
import entities.StateGetterPackage;
import enums.PortConfigurationEnum;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;

public class StateGetterReceiverService extends Thread {
    private AbstractSynchronizedResource<StateGetterPackage> stateGetterContainer;
    private SerializerService serializerService = SerializerService.getInstance();
    private DatagramSocket datagramSocket;

    public StateGetterReceiverService setStateGetterContainer(AbstractSynchronizedResource<StateGetterPackage> stateGetterContainer) {
        this.stateGetterContainer = stateGetterContainer;
        return this;
    }

    public StateGetterReceiverService() {
        try {
            datagramSocket = new DatagramSocket(PortConfigurationEnum.CLIENT_LISTEN_PORT.getContent());
        } catch (SocketException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void run() {
        while (true) {
            try {
                Thread.sleep(10);
                int bufferSize = datagramSocket.getReceiveBufferSize();
                byte[] buffer = new byte[bufferSize + 1];
                DatagramPacket packet = new DatagramPacket(buffer, 0, bufferSize);
                datagramSocket.receive(packet);
                String requestContent = new String(packet.getData());
                StateGetterPackage stateGetterPackage = serializerService.deserialize(requestContent, StateGetterPackage.class);
                stateGetterContainer.setResource(stateGetterPackage);
            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (SocketException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
