import containers.DataContainer;
import enums.PortConfigurationEnum;
import org.junit.Test;
import services.AnnouncerService;
import services.FinderService;

import static org.junit.Assert.assertEquals;

public class AnnouncerFinderTest {
    private AnnouncerService announcer = new AnnouncerService();
    private FinderService finder = new FinderService();
    private DataContainer container = DataContainer.getInstance();

//    @Test
    public void testAnnouncerFinderRelation() {
        String mockIp = "1.2.3.4";
        announcer
                .setTargetPort(PortConfigurationEnum.SERVER_ANNOUNCE_PORT.getContent())
                .setAnnouncementIp(mockIp)
                .setAnnouncementInstanceType("server")
                .setAnnouncementPort(PortConfigurationEnum.SERVER_LISTEN_PORT.getContent())
                .start();

        finder
                .setListenPort(PortConfigurationEnum.SERVER_ANNOUNCE_PORT.getContent())
                .setAddressContainer(container.getClientAddressContainer())
                .start();

        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {

        }

        assertEquals(mockIp, container.getClientAddress().getHostAddress());
    }
}
